use galactica_content::Content;
use rhai::{CustomType, TypeBuilder};
use std::{cell::RefCell, rc::Rc, sync::Arc};

use crate::ui::util::RadialBar;

#[derive(Debug, Clone)]
pub struct RadialElement {
	pub bar: Rc<RefCell<RadialBar>>,
	pub ct: Arc<Content>,
}

// TODO: remove this
unsafe impl Send for RadialElement {}
unsafe impl Sync for RadialElement {}

impl RadialElement {
	pub fn new(ct: Arc<Content>, bar: Rc<RefCell<RadialBar>>) -> Self {
		Self { ct, bar }
	}
}

impl CustomType for RadialElement {
	fn build(mut builder: TypeBuilder<Self>) {
		builder
			.with_name("RadialElement")
			.with_fn("set_val", |s: &mut Self, val: f32| {
				s.bar.borrow_mut().set_val(val)
			});
	}
}
